function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useCallback, useEffect, useLayoutEffect, useRef, useState } from 'react';
import { useSelectableContext } from "../context";
import { checkInRange } from "../utils";
import useUpdateEffect from "./useUpdateEffect";
export default function useSelectable(_ref) {
  var value = _ref.value,
    disabled = _ref.disabled,
    _ref$rule = _ref.rule,
    rule = _ref$rule === void 0 ? 'collision' : _ref$rule;
  var _useSelectableContext = useSelectableContext(),
    mode = _useSelectableContext.mode,
    scrollContainer = _useSelectableContext.scrollContainer,
    boxPosition = _useSelectableContext.boxPosition,
    isDragging = _useSelectableContext.isDragging,
    _useSelectableContext2 = _useSelectableContext.value,
    contextValue = _useSelectableContext2 === void 0 ? [] : _useSelectableContext2,
    startInside = _useSelectableContext.startInside,
    startTarget = _useSelectableContext.startTarget,
    selectingValue = _useSelectableContext.selectingValue,
    unmountItemsInfo = _useSelectableContext.unmountItemsInfo,
    virtual = _useSelectableContext.virtual,
    boxRef = _useSelectableContext.boxRef,
    compareFn = _useSelectableContext.compareFn;
  var node = useRef(null);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isInRange = _useState2[0],
    setIsInRange = _useState2[1];
  useEffect(function () {
    var _node$current;
    setIsInRange(checkInRange(rule, (_node$current = node.current) === null || _node$current === void 0 ? void 0 : _node$current.getBoundingClientRect(), scrollContainer, boxPosition, boxRef));
  }, [rule, scrollContainer, boxPosition]);
  var isSelected = contextValue.some(function (i) {
    return compareFn(i, value);
  });
  var isSelecting = isDragging && !disabled && isInRange;
  var isRemoving = isSelecting && isSelected && (mode === 'remove' || mode === 'reverse');
  var isAdding = isSelecting && !isSelected && (mode === 'add' || mode === 'reverse');
  var setNodeRef = useCallback(function (ref) {
    node.current = ref;
  }, []);
  useEffect(function () {
    if (startTarget && !startInside.current) {
      var _node$current2;
      var contain = (_node$current2 = node.current) === null || _node$current2 === void 0 ? void 0 : _node$current2.contains(startTarget);
      if (contain) {
        startInside.current = true;
      }
    }
  }, [startTarget]);
  useEffect(function () {
    if (selectingValue) {
      if (isSelecting) {
        selectingValue.current.push(value);
      } else {
        selectingValue.current = selectingValue.current.filter(function (i) {
          return !compareFn(i, value);
        });
      }
    }
  }, [isSelecting]);

  // collect item unmount information when virtual
  useLayoutEffect(function () {
    if (virtual) {
      unmountItemsInfo.current.delete(value);
      return function () {
        if (node.current && scrollContainer) {
          unmountItemsInfo.current.set(value, {
            rule: rule,
            rect: node.current.getBoundingClientRect(),
            disabled: disabled,
            scrollLeft: scrollContainer.scrollLeft,
            scrollTop: scrollContainer.scrollTop
          });
        }
      };
    }
  }, [virtual]);

  // update disabled when virtual and disabled changed
  useUpdateEffect(function () {
    if (virtual) {
      var info = unmountItemsInfo.current.get(value);
      if (info) {
        unmountItemsInfo.current.set(value, _objectSpread(_objectSpread({}, info), {}, {
          disabled: disabled,
          rule: rule
        }));
      }
    }
  }, [virtual, disabled, rule]);
  return {
    setNodeRef: setNodeRef,
    isSelecting: isSelecting,
    isRemoving: isRemoving,
    isSelected: isSelected,
    isAdding: isAdding,
    isDragging: isDragging
  };
}